<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row mb-3 mt-5">
          <label class="col-sm-2 col-form-label">Kode Proyek</label>
          <div class="col-sm-10">
            <b-form-input
              id="input-large"
              size="lg"
              v-model="project_code"
              disabled
            ></b-form-input>
          </div>
        </div>

        <div class="row mb-3 mt-5">
          <label class="col-sm-2 col-form-label">Nama Proyek</label>
          <div class="col-sm-10">
            <b-form-input
              id="input-large"
              size="lg"
              v-model="project_name"
              disabled
            ></b-form-input>
          </div>
        </div>

        <div class="row mb-3 mt-5">
          <label class="col-sm-2 col-form-label">Status</label>
          <div class="col-sm-10">
            <b-form-input
              id="input-large"
              size="lg"
              v-model="project_status"
              disabled
            ></b-form-input>
          </div>
        </div>
      </div>
    </div>

    <div>
      <b-card no-body>
        <b-tabs card v-model="tabs_change_management">
          <b-tab title="Change Management Info" active>
            <b-card-text>
              <div class="text-right mb-4">
                <button
                  class="btn btn-primary btn-md"
                  @click.prevent="saveInfo()"
                >
                  <div
                    v-bind:class="{
                      'd-none': saveInfoText
                    }"
                  >
                    Simpan Info Change Management
                  </div>
                  <div
                    v-bind:class="{
                      'd-none': isLoading
                    }"
                  >
                    <b-spinner
                      variant="light"
                      tyle="width: 1rem; height: 1rem;"
                      label="Spinning"
                    ></b-spinner>
                  </div>
                </button>
              </div>

              <!-- form -->
              <div class="row">
                <div class="col-6">
                  <div class="row">
                    <label class="col-sm-2 col-form-label">Nomor CR</label>
                    <div class="col-sm-10">
                      <b-form-input
                        id="input-large"
                        size="lg"
                        v-model="cr_number"
                      ></b-form-input>
                    </div>
                  </div>
                </div>
                <div class="col-6">
                  <div class="row">
                    <label class="col-sm-5 col-form-label" for="date-arrived"
                      >Tanggal Diterima Dari Chief</label
                    >
                    <div class="col-sm-7">
                      <b-form-datepicker
                        id="date-send"
                        v-model="date_arrived"
                        class="mb-2"
                        size="lg"
                      ></b-form-datepicker>
                    </div>
                  </div>
                </div>
              </div>

              <div class="row">
                <div class="col-6">
                  <div class="row">
                    <label class="col-sm-2 col-form-label">Title</label>
                    <div class="col-sm-10">
                      <b-form-input
                        id="input-large"
                        size="lg"
                        v-model="title"
                      ></b-form-input>
                    </div>
                  </div>
                </div>
                <div class="col-6">
                  <div class="row">
                    <label class="col-sm-5 col-form-label" for="date-send"
                      >Tanggal Dikirim ke Engineer</label
                    >
                    <div class="col-sm-7">
                      <b-form-datepicker
                        id="date-send-info"
                        v-model="date_send"
                        class="mb-2"
                        size="lg"
                      ></b-form-datepicker>
                    </div>
                  </div>
                </div>
              </div>

              <div class="row">
                <div class="col-6">
                  <div class="row">
                    <label class="col-sm-2 col-form-label" for="date-cr"
                      >Tanggal CR</label
                    >
                    <div class="col-sm-10">
                      <b-form-datepicker
                        id="date-cr-info"
                        v-model="date_cr"
                        class="mb-2"
                        size="lg"
                      ></b-form-datepicker>
                    </div>
                  </div>
                </div>
              </div>
            </b-card-text>
          </b-tab>
          <b-tab title="Change Management Item">
            <b-card-text>
              <management-item />
            </b-card-text>
          </b-tab>
          <b-tab title="Design Terdampak">
            <b-card-text>
              <design-terdampak />
            </b-card-text>
          </b-tab>
          <b-tab title="PIC">
            <b-card-text>
              <b-card-text>
                <pic />
              </b-card-text>
            </b-card-text>
          </b-tab>
          <b-tab title="File">
            <b-card-text>
              <b-card-text>
                <file />
              </b-card-text>
            </b-card-text>
          </b-tab>
          <b-tab title="Response">
            <b-card-text>
              <response />
            </b-card-text>
          </b-tab>
          <b-tab title="Response to Chief">
            <b-card-text>
              <response-chief />
            </b-card-text>
          </b-tab>
        </b-tabs>
      </b-card>
    </div>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import {
  GET_CHANGE_MANAGEMENT,
  GET_DETAIL_CHANGE,
  POST_INFO_CHANGE_MANAGEMENT,
  RESET_CHANGE_MANAGEMENT
} from "@/core/services/store/change-management.module";
import ManagementItem from "./change-management/ManagementItem";
import DesignTerdampak from "./change-management/DesignTerdampak";
import Pic from "./change-management/Pic";
import File from "./change-management/File";
import Response from "./change-management/Response";
import ResponseChief from "./change-management/ResponseChief";

export default {
  name: "change-management",
  components: {
    ManagementItem,
    DesignTerdampak,
    Pic,
    File,
    Response,
    ResponseChief
  },
  data() {
    return {
      dialog: false,
      cr_number: "",
      project_name: "",
      project_code: "",
      project_status: "",
      nickname: "",
      date_arrived: "",
      date_send: "",
      date_cr: "",
      title: "",
      options: {
        statuses: [
          { value: null, text: "Pilih Status" },
          { value: "open", text: "Open" },
          { value: "close", text: "Close" }
        ]
      },
      saveInfoText: false,
      isLoading: true,
      tabs_change_management: 1
    };
  },
  methods: {
    openDialog() {
      this.dialog = true;
    },

    async saveInfo() {
      var data = {
        send: {
          cr_number: this.cr_number,
          title: this.title,
          date: this.date_cr,
          date_received_from_chief: this.date_arrived,
          date_sent_to_enginering: this.date_send
        },
        id: this.$route.params.id_change_management
      };

      this.isLoading = false;
      this.saveInfoText = true;

      await this.$store.dispatch(POST_INFO_CHANGE_MANAGEMENT, {
        payload: data
      });
      this.isLoading = true;
      this.saveInfoText = false;
      this.$bvToast.toast("Data berhasil di simpan.", {
        title: "Success",
        variant: "success",
        solid: true
      });
    }
  },
  async mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "Change Management" }]);

    this.$store.dispatch(GET_CHANGE_MANAGEMENT, { nickname: "", cr: "" });

    await this.$store.dispatch(GET_DETAIL_CHANGE, {
      id: this.$route.params.id_change_management
    });
    this.project_code = this.$store.getters.getterDetailChangeManagement.project.code;
    this.cr_number = this.$store.getters.getterDetailChangeManagement.cr_number;
    this.project_name = this.$store.getters.getterDetailChangeManagement.project.name;
    this.project_status = this.$store.getters.getterDetailChangeManagement.project.status;
    this.title = this.$store.getters.getterDetailChangeManagement.title;
    this.date_arrived =
      this.$store.getters.getterDetailChangeManagement
        .date_received_from_chief == null
        ? ""
        : this.$store.getters.getterDetailChangeManagement
            .date_received_from_chief;
    this.date_send =
      this.$store.getters.getterDetailChangeManagement
        .date_sent_to_enginering == null
        ? ""
        : this.$store.getters.getterDetailChangeManagement
            .date_sent_to_enginering;
    this.date_cr =
      this.$store.getters.getterDetailChangeManagement.date == null
        ? ""
        : this.$store.getters.getterDetailChangeManagement.date;
  },
  computed: {
    currentTabs() {
      return this.tabs_change_management;
    }
  },
  watch: {
    currentTabs(num) {
      // reset state
      if (num == 1) {
        // management item
        this.$store.dispatch(RESET_CHANGE_MANAGEMENT, {
          state: "management-item"
        });
      } else if (num == 2) {
        // design terdampak
        this.$store.dispatch(RESET_CHANGE_MANAGEMENT, {
          state: "design-terdampak"
        });
      } else if (num == 3) {
        // pic
        this.$store.dispatch(RESET_CHANGE_MANAGEMENT, { state: "pic" });
      } else if (num == 4) {
        // file
        this.$store.dispatch(RESET_CHANGE_MANAGEMENT, { state: "file" });
      } else if (num == 5) {
        // response
        this.$store.dispatch(RESET_CHANGE_MANAGEMENT, { state: "response" });
      } else if (num == 6) {
        // response to chief
        this.$store.dispatch(RESET_CHANGE_MANAGEMENT, {
          state: "responseChief"
        });
      }
    }
  }
};
</script>

<style></style>
